// Import the required packages
import { EditorState } from '@codemirror/state';

// Create an extension to return the selected line
export function SelectedLine (selectLine) {

  // Return the extension
  return EditorState.transactionExtender.of(transaction => {

    // console.log(transaction)

    // Check the annotation is the selection type
    if (transaction.annotations.some(({ value }) => String(value).indexOf('select') > -1)) {

      // Extract the doc from the new state
      const doc = transaction.state.doc;

      // Extract the start cursor position of the selected line
      let start = transaction.selection.main.from;

      // Define the selected line
      // let selected;

      // Attempt to find the selected line
      try {

        // Try select this line
        selectLine(doc.lineAt(start));
      
      // Error has been caught as at the end of the line, so step back one character
      } catch(e) {

        // Select the line
        start = (start - 1);
        selectLine(doc.lineAt(start));
      }

      // console.log(selected)

      // Return the selected line
      // return selected;
    }

    return {
      effects: null
    }
  });
}